package test.db;


// A package "globals" should exist, with a class "Cache" which holds the
// pointer to the UniversalCache.
import globals.Cache;

import org.aris.cache.universalcache.UniversalCache;

import org.aris.hldb.CS;

import org.jdom.Element;

import java.sql.CallableStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import java.util.Iterator;
import java.util.LinkedList;


// --- a holder for custom imports ---

/**
 * TABLE: CustomerCustomerDemo <P>
 *
 * hldbCached template. Please don't modify, inherit instead with the inherit mechanisms of OODBFramework,
 * or by extend-ing the class.<P>
 *
 * Caching notes: cascade on relationships is not supported by this cache. Corrupted data will exist
 * in the case after a delete or update which cascaded to other tables.<P>
 *
 * Use this class to perform any update or delete commands. If you have to do updates or deletes manually
 * in this table, you'll have to manually flush the cache too.<P>
 *
 * Use static member instance() instead of a constructor to get an object if you know the
 * primary key values.<P>
 *
 * This class was generated with the OODBFramework © 2004 Konstantine Kougios.<P>
 */
public class CustomerCustomerDemoCached extends CustomerCustomerDemoBase
    implements Cloneable {
    // ============================================================================
    // =                  Constructors                                            =
    // ============================================================================

    /**
     * Use this constructor to create a new row by calling the setters and then insert().
     *
     * Use static member instance() instead of a constructor to get an object if you know the
     * primary key values.<P>
     *
     */
    public CustomerCustomerDemoCached(CS cs) {
        super(cs);
    }

    /**
     * Get from primary key(s), also stores the row in the cache. This doesn't lookup
     * the cache, and is used internally. Use instance() to get the object.
     *
     * @param cs The hldb CS
     */
    protected CustomerCustomerDemoCached(CS cs, String CustomerID,
        String CustomerTypeID) throws SQLException {
        super(cs, CustomerID, CustomerTypeID);
        storeInCache();

        // template/debug was set to >0 during conversion
    }

    /**
     * Constructor by ResultSet (which must contain all columns = SELECT *). The row in rs is
     * fetched, and the object is created from this row. A clone of the object is cached too.
     * All modifications done to the object are not reflected to the cache, until an
     * update() or insert() is called.<P>
     *
     * Use static member instance() instead of a constructor to get an object if you know the
     * primary key values.<P>
     *
     * @param cs  A cache of callable statements
     * @param rs  the ResultSet
     */
    public CustomerCustomerDemoCached(CS cs, ResultSet rs)
        throws java.sql.SQLException {
        super(cs, rs);
    }

    /**
     * This is usefull for reusing of this class. Also, the constructors use this. Fetches the next row and
     * creates the object from the resultset. Also caches the object.<P>
     *
     * Use static member instance() instead of this, to get an object if you know the
     * primary key values.<P>
     *
     */
    public void setFromRs(ResultSet rs) throws SQLException {
        super.setFromRs(rs);
        storeInCache();
    }

    /**
     * Sets this row of CustomerCustomerDemo to reference the ref row of CustomerDemographics
     */
    public void setCustomerTypeIDRef(CustomerDemographicsCached ref) {
        setCustomerTypeID(ref.getCustomerTypeID());
    }

    /**
     * Gets this row of CustomerCustomerDemo from referenced row of CustomerDemographics
     */
    public CustomerDemographicsCached getCustomerTypeIDRef()
        throws SQLException, CloneNotSupportedException {
        return getCustomerTypeIDRef(cs);
    }

    /**
     * Gets this row of CustomerCustomerDemo from referenced row of CustomerDemographics
     */
    public CustomerDemographicsCached getCustomerTypeIDRef(CS cs)
        throws SQLException, CloneNotSupportedException {
        return CustomerDemographicsCached.instance(cs, getCustomerTypeID());
    }

    /**
     * Sets this row of CustomerCustomerDemo to reference the ref row of Customers
     */
    public void setCustomerIDRef(CustomersCached ref) {
        setCustomerID(ref.getCustomerID());
    }

    /**
     * Gets this row of CustomerCustomerDemo from referenced row of Customers
     */
    public CustomersCached getCustomerIDRef()
        throws SQLException, CloneNotSupportedException {
        return getCustomerIDRef(cs);
    }

    /**
     * Gets this row of CustomerCustomerDemo from referenced row of Customers
     */
    public CustomersCached getCustomerIDRef(CS cs)
        throws SQLException, CloneNotSupportedException {
        return CustomersCached.instance(cs, getCustomerID());
    }

    /**
     * Gets a LinkedList of CustomerCustomerDemoCached's by querying table field CustomerID
     * for equality with the same CustomerID as this instance.
     */
    public LinkedList getLinkedListWithSameValueOfCustomerID(int maxResults)
        throws SQLException {
        return getLinkedListWithCustomerIDValueOf(cs, getCustomerID(),
            maxResults);
    }

    /**
     * Gets a LinkedList of CustomerCustomerDemoCached's by querying table field CustomerID
     * for equality with the "value".
     */
    public static LinkedList getLinkedListWithCustomerIDValueOf(CS cs,
        String value, int maxResults) throws SQLException {
        CallableStatement cc = getResultSetWithCustomerIDValueOf(cs, value,
                maxResults);
        LinkedList ll = new LinkedList();

        try {
            ResultSet rs = cc.getResultSet();

            while (rs.next()) {
                ll.addLast(new CustomerCustomerDemoCached(cs, rs));
            }
        } finally {
            cs.freeCS(cc);
        }

        return ll;
    }

    /**
     * Gets an Iterator of CustomerCustomerDemoCached's by querying table field CustomerID
     * for equality with the same CustomerID as this instance.
     */
    public Iterator getIteratorWithSameValueOfCustomerID(int maxResults)
        throws SQLException {
        return getIteratorWithCustomerIDValueOf(cs, getCustomerID(), maxResults);
    }

    /**
     * Gets an Iterator of CustomerCustomerDemoCached's by querying table field CustomerID
     * for equality with the "value".
     */
    public static Iterator getIteratorWithCustomerIDValueOf(CS cs,
        String value, int maxResults) throws SQLException {
        return getLinkedListWithCustomerIDValueOf(cs, value, maxResults)
                   .iterator();
    }

    /**
     * Gets a LinkedList of CustomerCustomerDemoCached's by querying table field CustomerTypeID
     * for equality with the same CustomerTypeID as this instance.
     */
    public LinkedList getLinkedListWithSameValueOfCustomerTypeID(int maxResults)
        throws SQLException {
        return getLinkedListWithCustomerTypeIDValueOf(cs, getCustomerTypeID(),
            maxResults);
    }

    /**
     * Gets a LinkedList of CustomerCustomerDemoCached's by querying table field CustomerTypeID
     * for equality with the "value".
     */
    public static LinkedList getLinkedListWithCustomerTypeIDValueOf(CS cs,
        String value, int maxResults) throws SQLException {
        CallableStatement cc = getResultSetWithCustomerTypeIDValueOf(cs, value,
                maxResults);
        LinkedList ll = new LinkedList();

        try {
            ResultSet rs = cc.getResultSet();

            while (rs.next()) {
                ll.addLast(new CustomerCustomerDemoCached(cs, rs));
            }
        } finally {
            cs.freeCS(cc);
        }

        return ll;
    }

    /**
     * Gets an Iterator of CustomerCustomerDemoCached's by querying table field CustomerTypeID
     * for equality with the same CustomerTypeID as this instance.
     */
    public Iterator getIteratorWithSameValueOfCustomerTypeID(int maxResults)
        throws SQLException {
        return getIteratorWithCustomerTypeIDValueOf(cs, getCustomerTypeID(),
            maxResults);
    }

    /**
     * Gets an Iterator of CustomerCustomerDemoCached's by querying table field CustomerTypeID
     * for equality with the "value".
     */
    public static Iterator getIteratorWithCustomerTypeIDValueOf(CS cs,
        String value, int maxResults) throws SQLException {
        return getLinkedListWithCustomerTypeIDValueOf(cs, value, maxResults)
                   .iterator();
    }

    // ============================================================================
    // =                  Delete and Update methods                               =
    // ============================================================================

    /**
     * Delete the current object from database
     */
    public int delete() throws SQLException {
        return CustomerCustomerDemoCached.delete(cs, CustomerID, CustomerTypeID);
    }

    /**
     * Delete an row from database
     */
    public static int delete(CS cs, String CustomerID, String CustomerTypeID)
        throws SQLException {
        Cache.getCache().removeSynchronized(new Object[] {
                CustomerCustomerDemoCached.class, CustomerID, CustomerTypeID
            });

        return CustomerCustomerDemoBase.delete(cs, CustomerID, CustomerTypeID);
    }

    /**
     * Updates the object to the database, even the primary keys are updated (but not the autoincrements or autoincr PK's)
     */
    public int updateAll() throws SQLException {
        if (isDirty) {
            Cache.getCache().removeSynchronized(new Object[] {
                    CustomerCustomerDemoCached.class,
                    
                old_CustomerID, old_CustomerTypeID
                });

            int res = super.updateAll();
            storeInCache();

            return res;
        }

        return -1;
    }

    /**
     * Inserts this new object to a new row (all columns are inserted, except the identities)
     * Warning: This also sets any class member which reflects an autoincrement value in the DB, to the new value
     * as set by the insert into () sql.
     * For SQLServer this takes an additional query, since st.getGeneratedKeys() isn't implemented in mssql.jar.
     * Thus, some synchronization maybe necessary for this call to complete atomically.
     */
    public synchronized void insert() throws SQLException {
        super.insert();
        storeInCache();

        // template/debug was set to >0 during conversion
    }

    private final Object[] keysObj() {
        return new Object[] {
            CustomerCustomerDemoCached.class, CustomerID, CustomerTypeID
        };
    }

    private void storeInCache() {
        try {
            Cache.getCache().putSynchronized(keysObj(), this.clone());
        } catch (CloneNotSupportedException e) {
            // This should not occur.
            e.printStackTrace();
        }
    }

    /**
     * Flush all cached CustomerCustomerDemoCached items.
     */
    public static void flushCache() {
        Cache.getCache().flushSynchronized(new Object[] {
                CustomerCustomerDemoCached.class
            });
    }

    /**
     * Flush a cached CustomerCustomerDemoCached item.
     */
    public static void flushCache(String CustomerID, String CustomerTypeID) {
        Cache.getCache().removeSynchronized(new Object[] {
                CustomerCustomerDemoCached.class, CustomerID, CustomerTypeID
            });
    }

    private static CustomerCustomerDemoCached cacheLookup(String CustomerID,
        String CustomerTypeID) throws CloneNotSupportedException {
        // try to find the record in the cache
        UniversalCache c = Cache.getCache();

        synchronized (CustomerCustomerDemoCached.class) {
            CustomerCustomerDemoCached t = (CustomerCustomerDemoCached) c.get(new Object[] {
                        CustomerCustomerDemoCached.class, CustomerID,
                        CustomerTypeID
                    });

            if (t != null) {
                return (CustomerCustomerDemoCached) t.clone();
            }
        }

        return null;
    }

    /**
     * Returns an instance of this class, either by getting it from the memory cache (clone), or by querying the database. This
     * is the function that should be used, when the primary keys are known.<P>
     *
     * Any changes in this object are not reflected in the cache until update(), updateAll() or insert() is called.
     */
    public static CustomerCustomerDemoCached instance(CS cs, String CustomerID,
        String CustomerTypeID) throws SQLException, CloneNotSupportedException {
        CustomerCustomerDemoCached t = cacheLookup(CustomerID, CustomerTypeID);

        if (t != null) {
            return t;
        }

        // not in cache, search the database
        t = new CustomerCustomerDemoCached(cs, CustomerID, CustomerTypeID);

        return t;
    }

    /**
     * returns the XML form of this object and depth childs
     */
    public Element toXML(int depth)
        throws SQLException, CloneNotSupportedException {
        Element root = new Element("CustomerCustomerDemoCached");

        root.addContent(new Element("CustomerID").setText(getCustomerID()));

        root.addContent(new Element("CustomerTypeID").setText(
                getCustomerTypeID()));

        if (depth > 0) {
            CustomerDemographicsCached temp1 = getCustomerTypeIDRef(cs);

            if (temp1 != null) {
                root.addContent(temp1.toXML(depth - 1));
            }

            CustomersCached temp2 = getCustomerIDRef(cs);

            if (temp2 != null) {
                root.addContent(temp2.toXML(depth - 1));
            }
        }

        return root;
    }

    /**
     * returns the XML form of this object only
     */
    public Element toXML() throws SQLException, CloneNotSupportedException {
        return toXML(0);
    }

    public Object clone() throws CloneNotSupportedException {
        return super.clone();
    }
}
